﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace WDC_HighlightMarkers
{
    public partial class Form2 : Form
    {
        private const int ITEM_COUNT = 8000;
        private Random r = new Random();

        public Form2()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            var xAxis = new CategoryXAxis();
            var dt = this.CreateDataTable();
            xAxis.DataSource = dt;
            xAxis.Label = "ValuesX";

            var yAxis = new NumericYAxis();
            yAxis.MinimumValue = 0;

            LineSeries series = new LineSeries();
            series.DataSource = dt;
            series.XAxis = xAxis;
            series.YAxis = yAxis;
            series.ValueMemberPath = "ValuesY";
            series.ShowDefaultTooltip = true;
          

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);

            ultraDataChart1.Series.Add(series);

            CategoryHighlightLayer categoryHighlight = new CategoryHighlightLayer();
            categoryHighlight.TargetAxis = xAxis;
            categoryHighlight.BandHighlightWidth = 2;
            categoryHighlight.Thickness = 0;
            categoryHighlight.Brush = series.ActualBrush;
            ultraDataChart1.Series.Add(categoryHighlight);

            ItemToolTipLayer categoryTooltipLayer = new ItemToolTipLayer();
            categoryTooltipLayer.TargetSeries = series;
            categoryTooltipLayer.ShowDefaultTooltip = true;
            categoryTooltipLayer.ShouldRenderAsOverlay = false;
            ultraDataChart1.Series.Add(categoryTooltipLayer);

            CategoryItemHighlightLayer itemHighlight = new CategoryItemHighlightLayer();
            itemHighlight.TargetSeries = series;
            itemHighlight.Brush = itemHighlight.TargetSeries.ActualBrush;
            itemHighlight.Outline = itemHighlight.TargetSeries.ActualOutline;
            ultraDataChart1.Series.Add(itemHighlight);
        }

        private List<Data> CreateDataTable()
        {
            var list = new List<Data>();

            for (int i = 0; i < Form2.ITEM_COUNT; i++)
            {
                list.Add(new Data() { ValuesX = i, ValuesY = r.Next(0, 100) });
            }

            return list;
        }
    }

    public class Data
    {
        public int ValuesX { get; set; }
        public int ValuesY { get; set; }
    }
}
